@echo off
REM Uncomment line above to enable ECHO messages

REM 1. Initialization
ECHO.
SET LATEST_VERSION=
 
REM 2. Search JRE in Windows Registry
SET REG_KEY=HKLM\Software\JavaSoft\Java Runtime Environment
CALL :SEARCH_REG

REM 3. If JRE is not found in the Registry, check in there is a JDK entry in the Registry
IF DEFINED LATEST_VERSION (
	SET LATEST_JRE=%LATEST_VERSION%
) ELSE (
	SET LATEST_JRE=
	ECHO ERROR: JRE not found, search for JDK installation
	SET REG_KEY=HKLM\Software\JavaSoft\Java Development Kit
	CALL :SEARCH_REG
)

REM 4. Set JAVA_TYPE variable
IF DEFINED LATEST_JRE (
	SET JAVA_TYPE=Java Runtime Environment
	ECHO Using JRE version %LATEST_VERSION%	
) ELSE (
	IF DEFINED LATEST_VERSION (
		SET JAVA_TYPE=Java Development Kit
		SET LATEST_JDK=%LATEST_VERSION%
		ECHO Using JDK version %LATEST_JDK%	
	) ELSE (
		ECHO ERROR: JDK not found, giving up [Java not found]
	)
)
ECHO Found Java version: %LATEST_VERSION% (%JAVA_TYPE%)

REM 5. Find actual Java path from Registry entries
ECHO.
SET JAVA_PATH=
CALL :SEARCH_JAVA
GOTO RUN_FROM_REG
 
:SEARCH_REG
echo Searching Reg Key: %REG_KEY%
FOR /F "skip=2 tokens=2*" %%A IN ('REG QUERY "%REG_KEY%" /v CurrentVersion') DO (
	SET LATEST_VERSION=%%B
	REM ECHO For entry: %%B
)
GOTO :EOF

:SEARCH_JAVA
echo Searching Reg Key: %JAVA_TYPE%\%LATEST_VERSION%
FOR /F "skip=2 tokens=2*" %%A IN ('REG QUERY "HKLM\Software\JavaSoft\%JAVA_TYPE%\%LATEST_VERSION%" /v JavaHome') DO (
	SET JAVA_PATH=%%B
)
GOTO :EOF

:RUN_FROM_REG
REM Fixes "... was unexpected at this time" issue. For details see:
REM https://support.microsoft.com/en-us/help/2524009/error-running-command-shell-scripts-that-include-parentheses
SETLOCAL ENABLEDELAYEDEXPANSION
IF DEFINED JAVA_PATH (
	ECHO Using Java path: !JAVA_PATH!
	SET PATH=!PATH!;!JAVA_PATH!\bin
	GOTO RUN
) ELSE (
	ECHO on
	ECHO WARNING: Java path not found in Windows Registry
	REM Sometimes Java in not in the Windows Registry, but it is actually installed: just give it a try
	GOTO RUN
)

:RUN
REM STARTS ECARS-ENCR-QCS APPLICATION
start javaw -jar -Xmx1g qcs-library-1.8.jar -m=gui